
CW2Dymola  - Bug #79
CW2Dymola driver nelze pridat mezi ovladace CW 6.
17 April 2012 15:39 - Tomáš Kulhánek

Status: Resolved Start date: 17 April 2012
Priority: Normal Due date:
Assignee: Tomáš Kulhánek % Done: 100%
Category: Estimated time: 0.00 hour
Target version: Spent time: 10.00 hours
Description

CW2Dymola driver nelze pridat mezi ovladace CW 6 pres Nastroje -> Konfigurace ovladacu -> Pridat -> ... vybrano DLL. -> objevi se
dialog "Nelze zavest DLL"

1. vyzkousena verze ovladace zkompilovano s volbou "Character Set": MULTI-BYTE
2. vyzkousena verze ovladace zkompilovano s volbou "Character Set": UNICODE

prilozen soubor cw2dymoladriver se zdrojovymi kody ovladace - CW2DymolaDriver.cpp

History
#1 - 17 April 2012 15:46 - Tomáš Kulhánek

Control Web 6.1 SP8 UNICODE
platforma: Windows 2008 R2, SP1, Intel XEON (4 CPU)
           6 GB RAM
           (full virtualization on XEN 3.2)

#2 - 18 April 2012 14:19 - Tomáš Kulhánek

On 04/18/2012 01:40 PM, Mirek Zálešák wrote: 
Vaše knihovna CW2DymolaDriver.dll nevyváží žádné symboly. Měla by vyvýžet symboly, které CW očekává od ovladačů:

BufferInfo
Check
DisposeDriver
Done
DriverProc
GetDriverInfo
GetInput
Init
InputFinalized
InputRequest
InputRequestCompleted
MakeDriver
OutputFinalized
OutputRequest
OutputRequestCompleted
QueryProc
SetBufferAddr
Version
#3 - 18 April 2012 14:24 - Tomáš Kulhánek
- File cw2dymoladriver.dll added

opraven kompilovani a explicitne deklarovano makro
#define DLLEXPORT __declspec( dllexport )
pred kazdou funkci, jejiz symbol ma byt dostupny v DLL volano toto makro.
..
DLLEXPORT unsigned Version(void);
..

Nove zkompilovane DLL uz ma exportovane symboly - aspon podle DLL Export Viewer.
Nicmene toto nove DLL opet nelze pridat mezi ovladace CW.

#4 - 18 April 2012 14:28 - Tomáš Kulhánek
- % Done changed from 0 to 30

#5 - 18 April 2012 14:46 - Tomáš Kulhánek
- File cw2dymoladriver.zip added

#6 - 18 April 2012 14:46 - Tomáš Kulhánek
- File deleted (cw2dymoladriver.zip)

#7 - 19 April 2012 10:26 - Tomáš Kulhánek
- Status changed from New to Resolved
- % Done changed from 30 to 100

- funkce driveru musí být v C notaci volání (použití extern "C" {} a _cdecl)

#ifdef __cplusplus
extern "C" {
#endif
DLLEXPORT unsigned __cdecl Version();
...
#ifdef __cplusplus
}
#endif

- navíc všechny exportované symboly musí být explicitně deklarované (_declspec (dllexport))

#define DLLEXPORT __declspec( dllexport )
#define DLLEXPORTVOID DLLEXPORT void __cdecl
...
DLLEXPORTVOID GetDriverInfo(unsigned szDriverName, char *DriverName);
...
DLLEXPORTVOID DisposeDriver(HANDLE hDriver);
...

- závislé DLL (dymosim.dll a libdsdll.dll) ve stejném adresáři jako cw2dymoladriver.dll
#8 - 04 July 2012 10:27 - Tomáš Kulhánek
- Project changed from Physioserver to CW2Dymola 
- Category deleted (Podpůrná infrastruktura)
- Target version deleted (prototyp s control-webem)

Files
cw2dymoladriver.dll 88 KB 18 April 2012 Tomáš Kulhánek
cw2dymoladriver.zip 1.38 MB 18 April 2012 Tomáš Kulhánek

30 April 2025 3/3


